# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Aug 11 12:19:08 2022
#  Target Database = postgresql
#
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_fura.db.tables.irole_func_rel_exists import iRoleFuncRelExists
from bs_fura.db.tables.orole_func_rel_exists import oRoleFuncRelExists

class dRoleFuncRelExists:
    __slots__ = ("_dbcon", "_dbstmnt", "irec", "orec")

    def __init__(self, dbcon: mettle.db.IConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = iRoleFuncRelExists()
        self.orec     = None

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        self._dbstmnt = None

    def exec_deft(self,
                  site_id: int,
                  func_id: str,
                  role_id: str) -> "dRoleFuncRelExists":
        """
        Execute the query by setting all the inputs.

        :param site_id: int
        :param func_id: str
        :param role_id: str
        :return: Self for convenience.
        """
        self.irec.site_id = site_id
        self.irec.func_id = func_id
        self.irec.role_id = role_id

        return self.exec()

    def exec(self, irec: iRoleFuncRelExists = None) -> "dRoleFuncRelExists":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = self._dbcon.statement("RoleFuncRelExists", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  rfr.site_id
from
  fura.rolefuncrel rfr
where
  rfr.site_id = :siteId and
  rfr.func_id = :funcId and
  rfr.role_id = :roleId""")

        self._dbstmnt.bind_in("siteId", self.irec.site_id, int, 4)
        self._dbstmnt.bind_in("funcId", self.irec.func_id, str, 128)
        self._dbstmnt.bind_in("roleId", self.irec.role_id, str, 128)

        self._dbstmnt.bind_out("siteId", int, 4)

        self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    def fetch(self, must_exist: bool = False) -> bool:
        """
        Fetches the next row from the executed query.

        :param must_exist:
        :return: True if a row was fetched, else False.
        """
        if not self._dbcon.fetch(self._dbstmnt):
            if must_exist:
                raise mettle.lib.xMettle(f"Record not found: [table:RoleFuncRel, proc:Exists, row:{self.irec}]", err_code=mettle.lib.xMettle.eCode.DBNotFound)
            return False

        self.orec = oRoleFuncRelExists()

        self.orec.site_id = self._dbstmnt.result[0]

        return True

    def fetch_iter(self) -> oRoleFuncRelExists:
        """
        Yield all the rows one at a time.

        :return: Iterator for output rows
        """
        while self.fetch():
            yield self.orec

    def fetch_all(self, out_list: oRoleFuncRelExists.List, clear_list: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param out_list:
        :param clear_list:
        :return: Number of rows fetched.
        """
        if clear_list:
            out_list.clear()

        while self.fetch():
            out_list.append(self.orec)

        return len(out_list)

