# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Aug 11 12:19:09 2022
#  Target Database = postgresql
#
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_fura.db.tables.token_sentry_key import tTokenSentryKey
from bs_fura.db.tables.token_sentry import tTokenSentry

class dTokenSentrySelectOne:
    __slots__ = ("_dbcon", "_dbstmnt", "irec", "orec")

    def __init__(self, dbcon: mettle.db.IAConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = tTokenSentryKey()
        self.orec     = None

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        self._dbstmnt = None

    async def exec_deft(self,
                        site_id: int) -> "dTokenSentrySelectOne":
        """
        Execute the query by setting all the inputs.

        :param site_id: int
        :return: Self for convenience.
        """
        self.irec.site_id = site_id

        return await self.exec()

    async def exec(self, irec: tTokenSentryKey = None) -> "dTokenSentrySelectOne":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = await self._dbcon.statement("TokenSentrySelectOne", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  site_id,
  token_cnt,
  last_poll
from
  fura.TokenSentry
where
  site_id = :site_id""")

        self._dbstmnt.bind_in("site_id", self.irec.site_id, int, 4)

        self._dbstmnt.bind_out("site_id", int, 4)
        self._dbstmnt.bind_out("token_cnt", int, 8)
        self._dbstmnt.bind_out("last_poll", datetime.datetime)

        await self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    async def fetch(self, must_exist: bool = False) -> bool:
        """
        Fetches the next row from the executed query.

        :param must_exist:
        :return: True if a row was fetched, else False.
        """
        if not await self._dbcon.fetch(self._dbstmnt):
            if must_exist:
                raise mettle.lib.xMettle(f"Record not found: [table:TokenSentry, proc:SelectOne, row:{self.irec}]", err_code=mettle.lib.xMettle.eCode.DBNotFound)
            return False

        self.orec = tTokenSentry()

        self.orec.site_id = self._dbstmnt.result[0]
        self.orec.token_cnt = self._dbstmnt.result[1]
        self.orec.last_poll = self._dbstmnt.result[2]

        return True

    async def fetch_iter(self) -> tTokenSentry:
        """
        Yield all the rows one at a time.

        :return: Iterator for output rows
        """
        while await self.fetch():
            yield self.orec

    async def fetch_all(self, out_list: tTokenSentry.List, clear_list: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param out_list:
        :param clear_list:
        :return: Number of rows fetched.
        """
        if clear_list:
            out_list.clear()

        while await self.fetch():
            out_list.append(self.orec)

        return len(out_list)

