# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Aug 11 12:19:09 2022
#

import datetime
import uuid
import time
import dataclasses
import typing
import mettle.io
import mettle.db

@dataclasses.dataclass(slots=True)
class tTokenHist(mettle.io.ISerializable):

    site_id: int = dataclasses.field(default=0, compare=False)
    id: str = dataclasses.field(default='', compare=False)
    usr_id: str = dataclasses.field(default='', compare=False)
    date_created: typing.Optional[datetime.datetime] = dataclasses.field(default=None, compare=False)
    expires: typing.Optional[datetime.datetime] = dataclasses.field(default=None, compare=False)
    use_cnt: int = dataclasses.field(default=0, compare=False)
    aud_id: str = dataclasses.field(default='', compare=False)
    tm_stamp: typing.Optional[datetime.datetime] = dataclasses.field(default=None, compare=False)

    def clear(self):
        """
        Clears all member variables for this database record.
        """
        self.site_id = 0
        self.id = ''
        self.usr_id = ''
        self.date_created = None
        self.expires = None
        self.use_cnt = 0
        self.aud_id = ''
        self.tm_stamp = None

    def _name(self) -> str:
        """
        Name of the record.

        :return: The name.
        """
        return 'tTokenHist'

    def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
        """
        Serialize record to a stream.

        :param _w:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _w.write_start(_oname)
        _w.write_int32("site_id", self.site_id)
        _w.write_string("id", self.id)
        _w.write_string("usr_id", self.usr_id)
        _w.write_datetime("date_created", self.date_created)
        _w.write_datetime("expires", self.expires)
        _w.write_int32("use_cnt", self.use_cnt)
        _w.write_string("aud_id", self.aud_id)
        _w.write_datetime("tm_stamp", self.tm_stamp)
        _w.write_end(_oname)

    def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
        """
        Deserialize record from a stream.

        :param _r:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _r.read_start(_oname)
        self.site_id = _r.read_int32("site_id")
        self.id = _r.read_string("id")
        self.usr_id = _r.read_string("usr_id")
        self.date_created = _r.read_datetime("date_created")
        self.expires = _r.read_datetime("expires")
        self.use_cnt = _r.read_int32("use_cnt")
        self.aud_id = _r.read_string("aud_id")
        self.tm_stamp = _r.read_datetime("tm_stamp")
        _r.read_end(_oname)

    def _copy_from(self, rec: "tTokenHist"):
        """
        Copies the column from the rec into this record.

        :param rec: The source record.
        """
        self.site_id = rec.site_id
        self.id = rec.id
        self.usr_id = rec.usr_id
        self.date_created = rec.date_created
        self.expires = rec.expires
        self.use_cnt = rec.use_cnt
        self.aud_id = rec.aud_id
        self.tm_stamp = rec.tm_stamp

    @staticmethod
    def _cache_davs(dvc=None, for_ins: bool = False, key_only: bool = False):
        """
        Cache the DAV into the dav cache (or create one) and return it.

        :param dvc: (mettle.lib.DavCache), target cache, if None a new one is created and returned.
        :param for_ins: Davs for insert.
        :param key_only: Davs by key only, ie for delete/selectone.
        """
        if dvc is None:
            dvc = mettle.lib.DavCache()

        dvc.add_targ("site_id", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("id", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("id", mettle.lib.Dav(mettle.lib.Dav.eDavType.Max, 64))
        dvc.add_targ("usr_id", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("usr_id", mettle.lib.Dav(mettle.lib.Dav.eDavType.Max, 128))
        dvc.add_targ("date_created", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("expires", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("use_cnt", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("audId", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))

        return dvc

    def _get_davs(self, dvc=None, for_ins: bool = False, key_only: bool = False):
        tTokenHist._cache_davs(dvc, for_ins, key_only)

    def _write_key(self, _key: None):
        """
        Write primary key columns to _key.

        :param _key:
        """

    def _read_key(self, _key: None):
        """
        Read the primary key columns from _key.

        :param _key:
        """


    class List(list, mettle.io.ISerializable):
        """
        List Class
        """

        def _name(self) -> str:
            """
            Name of the list.

            :return: The name
            """
            return 'tTokenHist.List'

        def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
            """
            Serialize the list to a stream.

            :param _w:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _w.write_start_list(_oname, len(self))

            for _rec in self:
                _rec._serialize(_w)

            _w.write_end(_oname)

        def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
            """
            Deserialize the list from a stream.

            :param _r:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _cnt = _r.read_start_list(_oname)

            while _cnt >= 1:
                _rec  = tTokenHist()
                _cnt -= 1
                _rec._deserialize(_r)
                self.append(_rec)

            _r.read_end(_oname)

        def _get_davs(self, dvc=None, for_ins: bool = False, key_only: bool = False):
            return tTokenHist._cache_davs(dvc, for_ins, key_only)

